Index: branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/PGE.cs
===================================================================
--- branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/PGE.cs	(revision 16230)
+++ branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/PGE.cs	(revision 16231)
@@ -37,5 +37,5 @@
 
     [DllImport("go-pge.dll", EntryPoint = "stepW", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
-    public static extern void StepW();
+    public static extern int StepW();
 
     [DllImport("go-pge.dll", EntryPoint = "getStepResult", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
@@ -278,10 +278,10 @@
 
     protected override void Run(CancellationToken cancellationToken) {
-
       // TODO: the following is potentially problematic for other go processes run on the same machine at the same time
+      // shouldn't be problematic bc is inherited only, normally only child processes are affected
       Environment.SetEnvironmentVariable("GOGC", "off");
       Environment.SetEnvironmentVariable("GODEBUG", "cgocheck=0");
       Environment.SetEnvironmentVariable("CGO_ENABLED", "1");
-
+      Environment.SetEnvironmentVariable("PGEDEBUG", "0");
 
 
@@ -301,4 +301,7 @@
       IntPtr testData = GetData(problemData.Dataset, variables, problemData.TestIndices, out nTestData);
 
+      nTrainData = Problem.ProblemData.TrainingPartition.Size;
+      nTestData = Problem.ProblemData.TestPartition.Size;
+
       var inputVariableNames = string.Join(" ", problemData.AllowedInputVariables); 
       // TODO: does this work when input variables contain spaces?
@@ -322,5 +325,4 @@
 
 
-
       AddTestData(cIndepNames, cDependentNames, testData, nTestData);
 
@@ -343,7 +345,7 @@
         curItersItem.Value = iter;
 
-        StepW();  // TODO: alg crashes here
-
-        for (int iPeel = 0; iPeel < PeelCnt; iPeel++) {
+        int nResults = StepW();
+
+        for (int iResult = 0; iResult < nResults; iResult++) { 
           int nobestpush = 0;       //bool
           int bestNewMinError = 0;  //bool
@@ -357,28 +359,20 @@
           string eqnStr = Marshal.PtrToStringAnsi(eqn);
 
-          if (nobestpush == 1) 
-          {
-            Console.WriteLine("No best push");
-          } else {
-            Console.WriteLine("Push/Pop (" + bestlen1 + "," + bestlen2 + ") " + eqnStr);
-
-            StringBuilder sb = new StringBuilder("");
-            for (int iCoeff = 0; iCoeff < nCoeff; iCoeff++) {
-              double coeffVal = GetCoeffResult();
-              Console.WriteLine("Coeff: " + coeffVal);
-              sb.Append(coeffVal + "; ");
-            }
-
-            var curItersResult = new Result("Iteration " + iter + " " + iPeel, curItersItem);
-            var coeffItersResult = new Result("Coeff " + iter + " " + iPeel, new StringValue(sb.ToString()));
-
-            var bestQualityItem = new StringValue(eqnStr);
-            var bestQualityResult = new Result("Best quality " + iter + " " + iPeel, bestQualityItem);
-            Results.Add(curItersResult);
-            Results.Add(coeffItersResult);
-            Results.Add(bestQualityResult);
-   
+          Console.WriteLine("Push/Pop (" + bestlen1 + "," + bestlen2 + ") " + eqnStr);
+          StringBuilder sb = new StringBuilder("");
+          for (int iCoeff = 0; iCoeff < nCoeff; iCoeff++) {
+            double coeffVal = GetCoeffResult();
+            Console.WriteLine("Coeff: " + coeffVal);
+            sb.Append(coeffVal + "; ");
           }
 
+          var curItersResult = new Result("Iteration " + iter + " " + iResult, curItersItem);
+          var coeffItersResult = new Result("Coeff " + iter + " " + iResult, new StringValue(sb.ToString()));
+
+          var bestQualityItem = new StringValue(eqnStr);
+          var bestQualityResult = new Result("Best quality " + iter + " " + iResult, bestQualityItem);
+          Results.Add(curItersResult);
+          Results.Add(coeffItersResult);
+          Results.Add(bestQualityResult);
         }
 
@@ -389,4 +383,19 @@
       Marshal.FreeHGlobal(trainData);
       Marshal.FreeHGlobal(testData);
+
+      Marshal.FreeHGlobal(cIndepNames);
+      Marshal.FreeHGlobal(cDependentNames);
+
+      Marshal.FreeHGlobal(cInitMethod);
+      Marshal.FreeHGlobal(cGrowMethod);
+
+      Marshal.FreeHGlobal(cRoots);
+      Marshal.FreeHGlobal(cNodes);
+      Marshal.FreeHGlobal(cNonTrig);
+      Marshal.FreeHGlobal(cLeafs);
+
+      Marshal.FreeHGlobal(cName);
+      Marshal.FreeHGlobal(cProblemTypeString);
+
       // Results.Add(new Result("Execution time", new TimeSpanValue(this.ExecutionTime)));
     }
Index: branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/go-pge/plug/bbsr.go
===================================================================
--- branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/go-pge/plug/bbsr.go	(revision 16230)
+++ branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/go-pge/plug/bbsr.go	(revision 16231)
@@ -10,8 +10,4 @@
 
 func (PS *PgeSearch) GenInitExpr() *probs.ReportQueue {
-
-	fmt.Println("Call gen method")
-
-
 	switch PS.cnfg.initMethod {
 	case "method1":
Index: branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/go-pge/plug/pge.go
===================================================================
--- branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/go-pge/plug/pge.go	(revision 16230)
+++ branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/go-pge/plug/pge.go	(revision 16231)
@@ -32,10 +32,12 @@
 var probDepndNames []string
 
-var stepResult []*pge.PeelResult
-var lastStepRes *pge.PeelResult
+var stepResult probs.ExprReportArray
+var lastStepRes *probs.ExprReport
 var resultNr int
 
 var nCurrentCoeff int 
 var nMaxCoeff int
+
+var nLastResults int
 
 //export InitSearch
@@ -48,5 +50,5 @@
 	testDatasN = 0 
 	trainDatasN = 0
-
+	nLastResults = 0
 	cps.CreateDS(maxGen, pgeRptEpoch, pgeRptCount, pgeArchiveCap, peelCnt, evalrCount, zeroEpsilon, goInitMethod, goGrowMethod, sortType)
 	
@@ -79,5 +81,5 @@
 	probDepndNames = goDepndNames
 	
-	trainData.InitTrainDataF(goIndepNames, goDepndNames, matrix, nEntries)
+	trainData.InitTrainData(goIndepNames, goDepndNames, matrix, nEntries)
 	
 	trainDatas[trainDatasN] = trainData
@@ -93,5 +95,5 @@
 	goDepndNames := strings.Split(C.GoString(depndNames), " ")
 	
-	testData.InitTestDataF(goIndepNames, goDepndNames, matrix, nEntries)
+	testData.InitTrainData(goIndepNames, goDepndNames, matrix, nEntries)
 	testDatas[testDatasN] = testData
 	testDatasN++
@@ -135,4 +137,5 @@
     epcomm.Rpts = make(chan *probs.ExprReportArray, 64)
 	epcomm.Gen = make(chan [2]int, 64)
+	
 	fmt.Printf("6\n")
 	
@@ -195,23 +198,24 @@
 	*testscore = 0
 	
-	if resultNr < cps.GetPeelCount() {
+	if resultNr < len(stepResult) && stepResult != nil {
 		elem := stepResult[resultNr]
 		resultNr++
 		lastStepRes = elem
+		*bestlen1 = len(stepResult)
 		if(elem != nil) {
-			if elem.Nobestpush {
-				*nobestpush = 1;
-			} else {
-				if elem.BestNewMinErr {
-					*bestnewminerr = 1
-				}
-				*testscore = elem.TestScore
-				*ncoeff = len(elem.Coeff)
+			//if elem.Nobestpush {
+			//	*nobestpush = 1;
+			//} else {
+			//	if elem.BestNewMinErr {
+					*bestnewminerr = int(elem.TestError())
+			//	}
+				*testscore = elem.TestScore()
+				*ncoeff = len(elem.Coeff())
 				nCurrentCoeff = 0
-				nMaxCoeff = len(elem.Coeff)
-				*bestlen1 = elem.Bestlen1
-				*bestlen2 = elem.Bestlen2
-				return C.CString(elem.Expre.String())
-			}
+				nMaxCoeff = len(elem.Coeff())
+				//*bestlen1 = 0 //elem.Bestlen1
+				*bestlen2 = 0 //elem.Bestlen2
+				return C.CString(elem.Expr().String())
+			//}
 		}
 	}
@@ -226,5 +230,6 @@
 		//*item = elem.Coeff[i]
 		
-		res = lastStepRes.Coeff[nCurrentCoeff]
+		coeffs := lastStepRes.Coeff()
+		res = coeffs[nCurrentCoeff]
 	}
 	nCurrentCoeff++
@@ -233,7 +238,23 @@
 
 //export StepW
-func StepW() {
+func StepW() int {
 	resultNr = 0
-	stepResult = cps.SingleStep()
+	stepResult = nil
+	nRes := cps.Step()
+	
+	resu, ok := <-epcomm.Rpts
+	
+	//_ = ok
+	
+	resultNr = nLastResults
+	
+	nNew := 0
+	if ok && resu != nil {
+		stepResult = *resu
+		nNew = nRes - nLastResults
+		nLastResults = nRes
+	}
+		
+	return nNew
 }
 
Index: branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/go-pge/plug/pge_init_method_1.go
===================================================================
--- branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/go-pge/plug/pge_init_method_1.go	(revision 16230)
+++ branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/go-pge/plug/pge_init_method_1.go	(revision 16231)
@@ -12,4 +12,5 @@
 
 	GP := PS.cnfg.treecfg
+	fmt.Printf("%v\n", GP)
 
 	eList := make([]expr.Expr, 0)
@@ -31,20 +32,15 @@
 	// exprs.SetSort(PS.cnfg.sortType)
 	exprs.SetSort(probs.PESORT_PARETO_TST_ERR)
-	
+
 	for i, e := range eList {
-	
+		fmt.Printf("%d:  %v\n", i, e)
 		serial := make([]int, 0, 64)
 		serial = e.Serial(serial)
 		PS.Trie.InsertSerial(serial)
 		// on train data
-
-		//fmt.Printf("RegressExpr:  e: %v  || PS.prob: %v\n", e, PS.prob)
-		re := RegressExpr(e, PS.prob)  //DER DO
-		//fmt.Printf("RegressExpr:  e: %v  || PS.prob: %v || %v \n", e, PS.prob, re)
-		
+		re := RegressExpr(e, PS.prob)
 		re.SetUnitID(i)
 		exprs.Push(re)
 	}
-
 	exprs.Sort()
 	return exprs
Index: branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/go-pge/plug/pge_search.go
===================================================================
--- branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/go-pge/plug/pge_search.go	(revision 16230)
+++ branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/go-pge/plug/pge_search.go	(revision 16231)
@@ -17,5 +17,5 @@
 )
 
-type PgeConfig struct {
+type pgeConfig struct {
 	// search params
 	maxGen        int
@@ -40,5 +40,5 @@
 func pgeConfigParser(field, value string, config interface{}) (err error) {
 
-	PC := config.(*PgeConfig)
+	PC := config.(*pgeConfig)
 
 	switch strings.ToUpper(field) {
@@ -92,5 +92,5 @@
 type PgeSearch struct {
 	id   int
-	cnfg PgeConfig
+	cnfg pgeConfig
 	prob *probs.ExprProblem
 	iter int
@@ -151,7 +151,4 @@
 	return PS.cnfg.maxGen
 }
-func (PS *PgeSearch) GetPeelCount() int {
-	return PS.cnfg.peelCnt
-}
 func (PS *PgeSearch) SetMaxIter(iter int) {
 	PS.cnfg.maxGen = iter
@@ -183,12 +180,9 @@
 
 func (PS *PgeSearch) Init(done chan int, prob *probs.ExprProblem, logdir string, input interface{}) {
-
-	//fmt.Printf("Init'n PGE\n")
+	fmt.Printf("Init'n PGE\n")
 	// setup data
 
 	// open logs
 	PS.initLogs(logdir)
-	
-	PS.stop = false
 
 	// copy in common config options
@@ -201,8 +195,8 @@
 	PS.cnfg.simprules = srules
 
-	//fmt.Println("Roots:   ", PS.cnfg.treecfg.RootsS)
-	//fmt.Println("Nodes:   ", PS.cnfg.treecfg.NodesS)
-	//fmt.Println("Leafs:   ", PS.cnfg.treecfg.LeafsS)
-	//fmt.Println("NonTrig: ", PS.cnfg.treecfg.NonTrigS)
+	fmt.Println("Roots:   ", PS.cnfg.treecfg.RootsS)
+	fmt.Println("Nodes:   ", PS.cnfg.treecfg.NodesS)
+	fmt.Println("Leafs:   ", PS.cnfg.treecfg.LeafsS)
+	fmt.Println("NonTrig: ", PS.cnfg.treecfg.NonTrigS)
 
 	PS.GenRoots = make([]expr.Expr, len(PS.cnfg.treecfg.Roots))
@@ -226,5 +220,5 @@
 
 		case expr.VAR:
-			//fmt.Println("Use Vars: ", PS.cnfg.treecfg.UsableVars)
+			fmt.Println("Use Vars: ", PS.cnfg.treecfg.UsableVars)
 			for _, i := range PS.cnfg.treecfg.UsableVars {
 				PS.GenLeafs = append(PS.GenLeafs, expr.NewVar(i))
@@ -245,8 +239,8 @@
 	***/
 
-	//fmt.Println("Roots:   ", PS.GenRoots)
-	//fmt.Println("Nodes:   ", PS.GenNodes)
-	//fmt.Println("Leafs:   ", PS.GenLeafs)
-	//fmt.Println("NonTrig: ", PS.GenNonTrig)
+	fmt.Println("Roots:   ", PS.GenRoots)
+	fmt.Println("Nodes:   ", PS.GenNodes)
+	fmt.Println("Leafs:   ", PS.GenLeafs)
+	fmt.Println("NonTrig: ", PS.GenNonTrig)
 
 	// setup communication struct
@@ -260,5 +254,4 @@
 	PS.Best = probs.NewReportQueue()
 	PS.Best.SetSort(probs.GPSORT_PARETO_TST_ERR)
-
 	PS.Queue = PS.GenInitExpr()
 	PS.Queue.SetSort(probs.PESORT_PARETO_TST_ERR)
@@ -283,7 +276,5 @@
 			continue
 		}
-		re := RegressExpr(e, PS.prob)
-		//fmt.Printf("reg: %v\n", re)
-		PS.eval_out <- re
+		PS.eval_out <- RegressExpr(e, PS.prob)
 	}
 
@@ -293,5 +284,5 @@
 	fmt.Printf("Running PGE\n")
 
-	PS.Loop()
+	PS.loop()
 
 	fmt.Println("PGE exitting")
@@ -301,5 +292,5 @@
 }
 
-func (PS *PgeSearch) Loop() {
+func (PS *PgeSearch) loop() {
 
 	PS.checkMessages()
@@ -307,5 +298,5 @@
 
 		fmt.Println("in: PS.step() ", PS.iter)
-		PS.Step()
+		PS.step()
 
 		// if PS.iter%PS.cnfg.pgeRptEpoch == 0 {
@@ -357,5 +348,6 @@
 }
 
-func (PS *PgeSearch) Step() {
+func (PS *PgeSearch) step() {
+
 	loop := 0
 	eval_cnt := 0 // for channeled eval
@@ -437,4 +429,5 @@
 	// } // for sequential eval
 	PS.Queue.Sort()
+
 }
 
@@ -442,5 +435,7 @@
 	es := make([]*probs.ExprReport, PS.cnfg.peelCnt)
 	for p := 0; p < PS.cnfg.peelCnt && PS.Queue.Len() > 0; p++ {
+
 		e := PS.Queue.Pop().(*probs.ExprReport)
+
 		bPush := true
 		if len(e.Coeff()) == 1 && math.Abs(e.Coeff()[0]) < PS.cnfg.zeroEpsilon {
@@ -451,5 +446,5 @@
 
 		if bPush {
-			fmt.Printf("pop/push DO(%d,%d): %v\n", p, PS.Best.Len(), e.Expr())
+			fmt.Printf("pop/push(%d,%d): %v\n", p, PS.Best.Len(), e.Expr())
 			PS.Best.Push(e)
 		}
@@ -471,145 +466,4 @@
 	return es
 }
-
-
-type PeelResult struct {
-	Es *probs.ExprReport
-
-	Nobestpush bool
-	BestNewMinErr bool
-	
-	Bestlen1 int
-	Bestlen2 int
-	
-	Coeff []float64
-	TestScore int
-	
-	Expre expr.Expr
-	ExpreRe *probs.ExprReport
-}
-
-
-func (PS *PgeSearch) SingleStep() []*PeelResult {
-	loop := 0
-	eval_cnt := 0
-	PR := PS.peelRes()
-	
-	es := make([]*probs.ExprReport, len(PR))
-	
-	for i, elem := range PR {
-		es[i] = elem.ExpreRe
-	}
-	
-	ex := PS.expandPeeled(es)
-
-	for cnt := range ex {
-		E := ex[cnt]
-		if E == nil {
-			continue
-		}
-		for _, e := range E {
-			if e == nil {
-				continue
-			}
-			if !PS.cnfg.treecfg.CheckExpr(e) {
-				continue
-			}
-			serial := make([]int, 0, 64)
-			serial = e.Serial(serial)
-			ins := PS.Trie.InsertSerial(serial)
-			
-			if !ins {
-				continue
-			}
-			PS.eval_in <- e
-			eval_cnt++
-		}
-	}
-	for i := 0; i < eval_cnt; i++ {
-		re := <-PS.eval_out
-		if math.IsNaN(re.TestError()) || math.IsInf(re.TestError(), 0) {
-			continue
-		}
-		if re.TestError() < PS.minError {
-			PS.minError = re.TestError()
-		}
-		doIns := true
-		for _, c := range re.Coeff() {
-			if math.Abs(c) < PS.cnfg.zeroEpsilon {
-				doIns = false
-				break
-			}
-		}
-		if doIns {
-			re.SetProcID(PS.id)
-			re.SetIterID(PS.iter)
-			re.SetUnitID(loop)
-			re.SetUniqID(PS.neqns)
-			loop++
-			PS.neqns++
-			PS.Queue.Push(re)
-		}
-	}
-	PS.Queue.Sort()
-
-	PS.reportExpr()	
-	PS.iter++
-	
-	return PR
-}
-
-func (PS *PgeSearch) peelRes() []*PeelResult {
-	//es := make([]*probs.ExprReport, PS.cnfg.peelCnt)
-	PRes := make([]*PeelResult, PS.cnfg.peelCnt)
-	
-	for p := 0; p < PS.cnfg.peelCnt && PS.Queue.Len() > 0; p++ {
-		PR := new(PeelResult)
-		
-		PR.BestNewMinErr = false
-		PR.Nobestpush = false
-		
-		e := PS.Queue.Pop().(*probs.ExprReport)
-		
-		bPush := true
-		if len(e.Coeff()) == 1 && math.Abs(e.Coeff()[0]) < PS.cnfg.zeroEpsilon {
-			//fmt.Println("No Best Push")
-			PR.Nobestpush = true
-			p--
-			continue
-		}
-
-		if bPush {
-			//fmt.Printf("pop/push (%d,%d): %v\n", p, PS.Best.Len(), e.Expr())
-			PR.Bestlen1 = p
-			PR.Bestlen2 = PS.Best.Len()
-			PR.Expre = e.Expr()
-			PR.ExpreRe = e
-			PS.Best.Push(e)
-		}
-
-		//es[p] = e
-		PR.Es = e
-		PR.Coeff = e.Coeff()
-		PR.TestScore = e.TestScore()
-		
-		
-		if e.TestScore() > PS.maxScore {
-			PS.maxScore = e.TestScore()
-		}
-		if e.TestError() < PS.minError {
-			PS.minError = e.TestError()
-			PR.BestNewMinErr = true
-			//fmt.Printf("Best New Min Error:  %v\n", e)
-		}
-		if e.Size() > PS.maxSize {
-			PS.maxSize = e.Size()
-		}
-		
-		PRes[p] = PR
-	}
-	
-	return PRes
-}
-
 
 func (PS *PgeSearch) expandPeeled(es []*probs.ExprReport) [][]expr.Expr {
@@ -633,4 +487,5 @@
 		// fmt.Println()
 	}
+	fmt.Println("\n")
 	return eqns
 }
@@ -668,4 +523,6 @@
 
 func (PS *PgeSearch) Clean() {
+	// fmt.Printf("Cleaning PGE\n")
+
 	PS.errLogBuf.Flush()
 	PS.mainLogBuf.Flush()
@@ -673,4 +530,5 @@
 	PS.fitnessLogBuf.Flush()
 	PS.ipreLogBuf.Flush()
+
 }
 
@@ -747,14 +605,8 @@
 	if len(guess) > 0 {
 
-		//fmt.Printf("IMREGEXP %v %v\n", P.SearchType, P.SearchVar)
-		//fmt.Printf("REGPTrain %T | %#v | %v\n", P.Train, P.Train, P.Train)
-		//fmt.Printf("eqn %T | %#v | %v\n", eqn, eqn, eqn)
-		//fmt.Printf("guess %T | %#v | %v\n", guess, guess, guess)
+		// fmt.Printf("x_dims:  %d  %d\n", x_dim, x_dim2)
 
 		// Callback version
-		
-		
 		coeff = levmar.LevmarExpr(eqn, P.SearchVar, P.SearchType, guess, P.Train, P.Test)
-		
 
 		// Stack version
@@ -789,5 +641,4 @@
 	R = new(probs.ExprReport)
 	R.SetExpr(eqn) /*.ConvertToConstantFs(coeff)*/
-
 	R.SetCoeff(coeff)
 	R.Expr().CalcExprStats()
@@ -856,35 +707,2 @@
 	return
 }
-
-func (PS *PgeSearch) CreateDS(maxGen int, pgeRptEpoch int, pgeRptCount int, pgeArchiveCap int, peelCnt int, evalrCount int, zeroEpsilon float64, initMethod string, growMethod string, sortType int) {
-	PS.id = 0 //maxGen
-	
-	var PC PgeConfig
-	
-	PC.pgeRptEpoch = pgeRptEpoch
-	PC.pgeRptCount = pgeRptCount
-	PC.pgeArchiveCap = pgeArchiveCap
-	PC.peelCnt = peelCnt
-	PC.evalrCount = evalrCount
-	PC.zeroEpsilon = zeroEpsilon
-	PC.initMethod = initMethod
-	PC.growMethod = growMethod
-
-	if sortType == 1 {
-		PC.sortType = probs.PESORT_PARETO_TRN_ERR
-	} else {	
-		PC.sortType = probs.PESORT_PARETO_TST_ERR
-	}
-
-	PC.maxGen = maxGen
-	PS.cnfg = PC
-		
-	PS.iter = 0
-}
-
-func (PS *PgeSearch) SetProb(ep *probs.ExprProblem) {
-	PS.prob = ep
-}
-func (PS *PgeSearch) GetIter() int {
-	return PS.iter
-}
Index: branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/go-pge/problems/benchmarks.go
===================================================================
--- branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/go-pge/problems/benchmarks.go	(revision 16230)
+++ branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/go-pge/problems/benchmarks.go	(revision 16231)
@@ -3,5 +3,5 @@
 import (
 	// "fmt"
-	expr "github.com/verdverm/go-symexpr"
+	expr "github.com_del/verdverm/go-symexpr"
 	"math"
 	"math/rand"
Index: branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/go-pge/problems/data.go
===================================================================
--- branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/go-pge/problems/data.go	(revision 16230)
+++ branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/go-pge/problems/data.go	(revision 16231)
@@ -8,6 +8,4 @@
 	"math/rand"
 	"os"
-	"C"
-	"unsafe"
 )
 
@@ -128,57 +126,4 @@
 }
 
-func (trainData *PointSet) InitTrainDataF(indepNames []string, depndNames []string, matrix unsafe.Pointer, nEntries int) {
-	trainData.ReadPointSet("C:/Users/Hansi/Desktop/Data.trn")
-}
-
-func (trainData *PointSet) InitTestDataF(indepNames []string, depndNames []string, matrix unsafe.Pointer, nEntries int) {
-	trainData.ReadPointSet("C:/Users/Hansi/Desktop/Data.tst")
-}
-
-func (trainData *PointSet) InitTrainData(indepNames []string, depndNames []string, matrix unsafe.Pointer, nEntries int) {
-	trainData.indepNames = indepNames  //First line in .trn file
-	trainData.numDim = len(trainData.indepNames)
-	trainData.depndNames = depndNames //Second line in .trn file
-	
-	fmt.Printf("Var Names = %v | %v\n", trainData.depndNames, trainData.indepNames)
-	var nClum int = len(indepNames) + len(depndNames)
-
-	for i := 0; i < nEntries; i++ {
-		var pnt Point 
-		for j := 0; j < len(trainData.indepNames); j++ {
-			elemNr := i * nClum + j
-			item := (*float64) (unsafe.Pointer( uintptr(unsafe.Pointer(matrix)) + unsafe.Sizeof(float64(0)) * uintptr(elemNr) ))
-			pnt.indep = append(pnt.indep, *item)
-			
-			if os.Getenv("PGEDEBUG") == "1" {
-				fmt.Printf("Adding independend Test/Train Data (%v,%v): %v\n", i, j, *item)
-			}
-		}
-
-		for j := len(trainData.indepNames); j < (len(trainData.indepNames) + len(trainData.depndNames)); j++ {
-			elemNr := i * nClum + j
-			item := (*float64) (unsafe.Pointer( uintptr(unsafe.Pointer(matrix)) + unsafe.Sizeof(float64(0)) * uintptr(elemNr) ))
-			pnt.depnd = append(pnt.depnd, *item )
-			
-			if os.Getenv("PGEDEBUG") == "1" {
-				fmt.Printf("Adding dependend (right side) Test/Train Data (%v, %v): %v\n", i, j, *item)
-			}
-		}
-
-		if len(pnt.indep) > 0 {
-			trainData.dataPoints = append(trainData.dataPoints, pnt)
-		}
-	}
-	fmt.Printf("Num Points: %v\n", len(trainData.dataPoints))
-	
-	//if os.Getenv("PGEDEBUG") == "2" {
-	//	DebugPrint(trainData)
-	//}
-}
-
-//func (trainData *PointSet) DebugPrint() {
-//	for index, elem in range 
-//}
-
 func (d *PointSet) ReadPointSet(filename string) {
 	ftotal, err := os.OpenFile(filename, os.O_RDONLY, 0)
Index: branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/go-pge/problems/problem.go
===================================================================
--- branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/go-pge/problems/problem.go	(revision 16230)
+++ branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/go-pge/problems/problem.go	(revision 16231)
@@ -7,5 +7,5 @@
 	"strings"
 
-	expr "github.com/verdverm/go-symexpr"
+	expr "github.com_del/verdverm/go-symexpr"
 )
 
@@ -166,15 +166,2 @@
 	return list[0:i]
 }
-
-
-func (ep *ExprProblem) CreatePS(Name string, MaxIter int, HitRatio float64, SearchVar int, ProblemTypeString string) {	//IndepNames []string, DepndNames []string, SysNames []string
-	ep.SearchType = ProblemTypeFromString(ProblemTypeString)
-	ep.Name = Name
-	
-	ep.TrainFns = append(ep.TrainFns, "dummy")
-	ep.TestFns = append(ep.TestFns, "dummy")
-		
-	ep.MaxIter = MaxIter
-	ep.HitRatio = HitRatio
-	ep.SearchVar = SearchVar
-}
Index: branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/go-pge/problems/report.go
===================================================================
--- branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/go-pge/problems/report.go	(revision 16230)
+++ branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/go-pge/problems/report.go	(revision 16231)
@@ -4,5 +4,5 @@
 	"container/list"
 	"fmt"
-	expr "github.com/verdverm/go-symexpr"
+	expr "github.com_del/verdverm/go-symexpr"
 	"sort"
 )
Index: branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/go-pge/problems/treeparams.go
===================================================================
--- branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/go-pge/problems/treeparams.go	(revision 16230)
+++ branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/go-pge/problems/treeparams.go	(revision 16231)
@@ -8,5 +8,5 @@
 	"strings"
 
-	expr "github.com/verdverm/go-symexpr"
+	expr "github.com_del/verdverm/go-symexpr"
 )
 
@@ -297,24 +297,2 @@
 	tp.TmpMinSize, tp.TmpMinDepth = tp.MinSize, tp.MinDepth
 }
-
-
-func (TP *TreeParams) CreateTreeParams(Roots string, Nodes string, NonTrig string, Leafs string, UsableVars []int, MaxSize int, MinSize int, MaxDepth int, MinDepth int) {
-	TP.RootsS = strings.Fields(Roots)
-	TP.RootsT, TP.Roots = fillExprStuff(TP.RootsS)
-	
-	TP.NodesS = strings.Fields(Nodes)
-	TP.NodesT, TP.Nodes = fillExprStuff(TP.NodesS)
-	
-	TP.NonTrigS = strings.Fields(NonTrig)
-	TP.NonTrigT, TP.NonTrig = fillExprStuff(TP.NonTrigS)
-	
-	TP.LeafsS = strings.Fields(Leafs)
-	TP.LeafsT, TP.Leafs = fillExprStuff(TP.LeafsS)
-
-	TP.UsableVars = UsableVars
-
-	TP.MaxSize = MaxSize
-	TP.MinSize = MinSize
-	TP.MaxDepth = MaxDepth
-	TP.MinDepth = MinDepth
-}
Index: branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/pge/bbsr.go
===================================================================
--- branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/pge/bbsr.go	(revision 16231)
+++ branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/pge/bbsr.go	(revision 16231)
@@ -0,0 +1,94 @@
+package pge
+
+import (
+	"fmt"
+	// "sort"
+
+	probs "github.com/verdverm/go-pge/problems"
+	expr "github.com/verdverm/go-symexpr"
+)
+
+func (PS *PgeSearch) GenInitExpr() *probs.ReportQueue {
+	switch PS.cnfg.initMethod {
+	case "method1":
+		return PS.GenInitExprMethod1()
+	case "method2":
+		return PS.GenInitExprMethod2()
+	case "method3":
+		return PS.GenInitExprMethod3()
+	default:
+		fmt.Println("Unknown init method")
+	}
+	return nil
+}
+
+func (PS *PgeSearch) Expand(O expr.Expr) (ret []expr.Expr) {
+	var exprs []expr.Expr
+
+	switch PS.cnfg.growMethod {
+	case "method1":
+		exprs = PS.ExpandMethod1(O)
+	case "method2":
+		exprs = PS.ExpandMethod2(O)
+	case "method3":
+		exprs = PS.ExpandMethod3(O)
+	default:
+		fmt.Println("Unknown expand method")
+	}
+
+	// convert and simplify
+	for i, e := range exprs {
+		if e == nil {
+			continue
+		}
+		defer func() {
+			if r := recover(); r != nil {
+				fmt.Printf("Recovered in Expand %v   %d %v", r, i, e)
+				exprs[i] = nil
+			}
+		}()
+		c := make([]float64, 0)
+		// fmt.Printf("Preconv   %v\n", e)
+		c, eqn := e.ConvertToConstants(c)
+		e.CalcExprStats()
+		// fmt.Printf("Postconv  %v\n", eqn)
+
+		// fmt.Printf("Presimp  %v\n", eqn)
+		exprs[i] = eqn.Simplify(PS.cnfg.simprules)
+		// fmt.Printf("Postsimp  %v\n\n", exprs[i])
+		// serial := make([]int, 0, 64)
+		// serial = exprs[i].Serial(serial)
+		// fmt.Printf("Postsimp  %v   %v\n\n", exprs[i], serial)
+	}
+
+	// sort.Sort(expr.ExprArray(exprs))
+
+	// remove duplicates
+
+	// last := 0
+	// for last < len(exprs) && exprs[last] == nil {
+	// 	last++
+	// }
+	// for i := last + 1; i < len(exprs); i++ {
+	// 	if exprs[i] == nil {
+	// 		continue
+	// 	}
+	// 	if exprs[i].AmIAlmostSame(exprs[last]) {
+	// 		exprs[i] = nil
+	// 	} else {
+	// 		last = i
+	// 	}
+	// }
+
+	// copy to ret, ignoring nil & bad expressions ...
+	for _, e := range exprs {
+		if e == nil {
+			continue
+		}
+		// if !PS.cnfg.treecfg.CheckExpr(e) {
+		// 	continue
+		// }
+		ret = append(ret, e)
+	}
+	return ret
+}
Index: branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/pge/ipre_trie.go
===================================================================
--- branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/pge/ipre_trie.go	(revision 16231)
+++ branches/2929_PrioritizedGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.PGE/3.3/go-code/pge/ipre_trie.go	(revision 16231)
@@ -0,0 +1,42 @@
+package pge
+
+type IpreNode struct {
+	val int
+	cnt int
+	vst int
+
+	next map[int]*IpreNode
+}
+
+func (n *IpreNode) InsertSerial(s []int) (did_ins bool) {
+	in, _ := n.next[s[0]]
+
+	// does this branch exist?
+	if in == nil {
+		in = new(IpreNode)
+		in.val = s[0]
+		in.next = make(map[int]*IpreNode)
+		n.next[s[0]] = in
+		did_ins = true
+	}
+
+	// recursive call to insert
+	if len(s) > 1 {
+		did_ins = in.InsertSerial(s[1:]) || did_ins
+	}
+
+	// visitation accounting  
+	// (-1 is the root of the memoization tree)
+	in.vst++
+	if n.val == -1 {
+		n.vst++
+	}
+	if did_ins {
+		in.cnt++
+		if n.val == -1 {
+			n.cnt++
+		}
+	}
+
+	return did_ins
+}
